<?php

namespace Drupal\persian_date\Plugin\views\filter;
use Drupal\persian_date\Library\Jalali\jDateTime;

/**
 * Filter to handle dates stored as a timestamp.
 *
 * @ingroup views_filter_handlers
 *
 * @ViewsFilter("date")
 */
class Date extends \Drupal\views\Plugin\views\filter\Date {

  protected function opSimple($field) {
    $value = (jDateTime::createCarbonFromFormat('Y-m-d H:i:s',$this->value['value']. ' 23:59:59'));
    $timestamp = $value->getTimestamp();
    $value = intval($timestamp);
    if (!empty($this->value['type']) && $this->value['type'] == 'offset') {
      // Keep sign.
      $value = '***CURRENT_TIME***' . sprintf('%+d', $value);
    }
    // This is safe because we are manually scrubbing the value.
    // It is necessary to do it this way because $value is a formula when using an offset.
    $this->query->addWhereExpression($this->options['group'], "$field $this->operator $value");
  }

}
